//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/View/Mask/MaskGraphicsProxy.h
//! @brief     Defines class MaskGraphicsProxy
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_VIEW_MASK_MASKGRAPHICSPROXY_H
#define BORNAGAIN_GUI_VIEW_MASK_MASKGRAPHICSPROXY_H

#include <QGraphicsProxyWidget>

class Data2DItem;

//! Graphics proxy to place QWidget inside QGraphicsScene, used by MaskEditorCanvas.

class MaskGraphicsProxy : public QGraphicsProxyWidget {
    Q_OBJECT
public:
    MaskGraphicsProxy();
    ~MaskGraphicsProxy() override;

    int type() const override;

    void setInZoomMode(bool value);

private:
    void mousePressEvent(QGraphicsSceneMouseEvent* event) override;
    void mouseMoveEvent(QGraphicsSceneMouseEvent* event) override;
    void mouseReleaseEvent(QGraphicsSceneMouseEvent* event) override;
    void wheelEvent(QGraphicsSceneWheelEvent* event) override;

    bool m_send_signals_to_colormap;
};

#endif // BORNAGAIN_GUI_VIEW_MASK_MASKGRAPHICSPROXY_H
